/// <reference types="node" />
export interface IpfsDeployerConfig {
    host: string;
    port: number;
    protocol: 'http' | 'https' | string;
}
export interface IpfsDeployerFile {
    path: string;
    content?: Buffer;
}
export interface IpfsDeployerResult {
    rootHash: string;
    nodes: {
        path: string;
        hash: string;
        size: number;
    }[];
}
export declare class IpfsDeployer {
    private ipfs;
    constructor(config?: Partial<IpfsDeployerConfig>);
    deployFiles(files: IpfsDeployerFile[]): Promise<IpfsDeployerResult>;
    deployFolder(path: string): Promise<IpfsDeployerResult>;
}
