"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var glob_1 = __importDefault(require("glob"));
var ipfs_http_client_1 = __importDefault(require("ipfs-http-client"));
var defaultConfig = {
    host: 'ipfs.infura.io',
    port: 5001,
    protocol: 'https',
};
var IpfsDeployer = /** @class */ (function () {
    function IpfsDeployer(config) {
        if (config === void 0) { config = {}; }
        this.ipfs = new ipfs_http_client_1.default(__assign({}, defaultConfig, config));
    }
    IpfsDeployer.prototype.deployFiles = function (files) {
        return __awaiter(this, void 0, void 0, function () {
            var results, rootHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ipfs
                            .add(files.map(function (file) { return (__assign({}, file, { path: "root/" + file.path })); }))];
                    case 1:
                        results = _a.sent();
                        results = results
                            .map(function (file) { return (__assign({}, file, { path: file.path.replace(/^root\/?/, './') })); });
                        rootHash = results.find(function (_a) {
                            var path = _a.path;
                            return path === './';
                        }).hash;
                        return [2 /*return*/, { rootHash: rootHash, nodes: results }];
                }
            });
        });
    };
    IpfsDeployer.prototype.deployFolder = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var paths, files;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        path = path.replace(/^\//, '').replace(/\/$/, '');
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                glob_1.default(path + "/**", function (error, matches) { return error ? reject(error) : resolve(matches); });
                            })];
                    case 1:
                        paths = _a.sent();
                        files = paths
                            .filter(function (_) { return _ !== path; })
                            .map(function (_) { return ({
                            path: _.replace(path + "/", ''),
                            content: fs_1.default.readFileSync(_),
                        }); });
                        return [2 /*return*/, this.deployFiles(files)];
                }
            });
        });
    };
    return IpfsDeployer;
}());
exports.IpfsDeployer = IpfsDeployer;
//# sourceMappingURL=ipfs-deployer.js.map