#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = __importDefault(require("commander"));
var ipfs_deployer_1 = require("./ipfs-deployer");
// tslint:disable-next-line
var packageJson = require('../package.json');
commander_1.default
    .version(packageJson.version)
    .description(packageJson.description)
    .usage('[options] <path>')
    .option('-h, --host <name>', 'IPFS host name', 'ipfs.infura.io')
    .option('-p, --port <port>', 'IPFS port', 5001)
    .option('--protocol <http|https|...>', 'IPFS protocol', 'https')
    .option('--only-hash', 'Returns only root hash.')
    .option('--json', 'Returns full JSON data.')
    .action(function (folder) { return __awaiter(_this, void 0, void 0, function () {
    var host, port, protocol, onlyHash, json;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (typeof folder !== 'string') {
                    console.error('Path not defined. Use `--help`,');
                    process.exit(1);
                }
                host = commander_1.default.host, port = commander_1.default.port, protocol = commander_1.default.protocol, onlyHash = commander_1.default.onlyHash, json = commander_1.default.json;
                return [4 /*yield*/, deploy(folder, host, +port, protocol, onlyHash, json)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); })
    .parse(process.argv);
function deploy(folder, host, port, protocol, onlyHash, json) {
    return __awaiter(this, void 0, void 0, function () {
        var config, ipfsDeployer, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = { host: host, port: port, protocol: protocol };
                    Object.keys(config)
                        .forEach(function (key) { return config[key] || delete config[key]; });
                    if (!onlyHash && !json) {
                        console.log("Deploying files inside \"" + folder + "\".");
                    }
                    ipfsDeployer = new ipfs_deployer_1.IpfsDeployer(config);
                    return [4 /*yield*/, ipfsDeployer.deployFolder(folder)];
                case 1:
                    result = _a.sent();
                    switch (true) {
                        case json:
                            console.log(JSON.stringify(result, null, 2));
                            break;
                        case onlyHash:
                            console.log(result.rootHash);
                            break;
                        default:
                            console.log("Deployed " + result.nodes.length + " nodes.");
                            console.log("Root hash: " + result.rootHash);
                            break;
                    }
                    return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=ipfs-website-deployer-cli.js.map